package com.fjhx.utils;

import cn.hutool.core.thread.ThreadUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class RetryUtil {

    /**
     * 重试机制
     */
    public static boolean execute(RetryRunnable runnable) {
        return execute(runnable, 0, 3, 1000L);
    }

    public static boolean execute(RetryRunnable runnable, int executeCount, int maxCount, Long sleep) {

        if (executeCount >= maxCount) {
            return false;
        }

        try {
            runnable.run();
            return true;
        } catch (Exception e) {
            log.error("runnable.run()", e);
            ThreadUtil.sleep(sleep);
            return execute(runnable, ++executeCount, maxCount, sleep);
        }
    }


    public interface RetryRunnable {
        void run() throws Exception;
    }

}
